# AIListWindow Struct Reference

Window that let you choose an available AI. More...

Inheritance diagram for AIListWindow:

## Public Member Functions
| AIListWindow (const WindowDesc *desc, CompanyID slot)
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
void | ChangeAI ()
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnResize ()
| Called after the window got resized.
virtual void | OnInvalidateData (int data=0, bool gui_scope=true)
| Some data on this window has become invalid.
## Data Fields
const AIInfoList * | ai_info_list
int | selected
CompanyID | slot
int | line_height
Scrollbar * | vscroll

## Detailed Description

Window that let you choose an available AI.

Definition at line 47 of file ai_gui.cpp.

## Member Function Documentation

virtual void AIListWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 90 of file ai_gui.cpp.

References AIL_WIDGET_INFO_BG, AIL_WIDGET_LIST, DrawString(), DrawStringMultiLine(), FONT_HEIGHT_NORMAL, ScriptFileInfo::GetAuthor(), ScriptFileInfo::GetDescription(), ScriptFileInfo::GetURL(), ScriptFileInfo::GetVersion(), Scrollbar::IsVisible(), SetDParam(), SetDParamStr(), WD_FRAMERECT_BOTTOM, WD_FRAMERECT_TOP, WD_FRAMETEXT_LEFT, WD_FRAMETEXT_RIGHT, WD_MATRIX_LEFT, WD_MATRIX_RIGHT, WD_MATRIX_TOP, and WD_PAR_VSEP_NORMAL.

virtual void AIListWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 150 of file ai_gui.cpp.

References AIL_WIDGET_ACCEPT, AIL_WIDGET_CANCEL, AIL_WIDGET_LIST, Scrollbar::GetScrolledRowFromWidget(), and Window::SetDirty().

virtual void AIListWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true` |
| ) |  |  | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | Information about the changed data.
  | gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 190 of file ai_gui.cpp.

References Scrollbar::GetCount(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_company_pool >::IsValidID(), min(), and Scrollbar::SetCount().

virtual void AIListWindow::OnResize | ( |  | ) | `[inline, virtual]`

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 178 of file ai_gui.cpp.

References AIL_WIDGET_LIST, NWidgetBase::current_y, Scrollbar::GetCapacity(), MAT_COL_START, MAT_ROW_START, Scrollbar::SetCapacity(), and NWidgetCore::widget_data.

virtual void AIListWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 79 of file ai_gui.cpp.

References AIL_WIDGET_LIST, FONT_HEIGHT_NORMAL, GB(), MAT_ROW_BITS, MAT_ROW_START, WD_MATRIX_BOTTOM, and WD_MATRIX_TOP.

The documentation for this struct was generated from the following file:

- src/ai/ai_gui.cpp